﻿------------------------------------------
--           Dyeing Set & Match         --
--               by Khrill              --
--                                      --
--                v 1.4.0               --
------------------------------------------


local KDSM = {}
KDSM.name  = "KhrillDyeingSetMatch"
KDSM.version = "1.4.0"

KDSM.defaults = {
	enable	= true,
	anchor	= {TOPRIGHT, TOPRIGHT, 0, 0},
	savedSets = {},
	classId = nil,
	charButton = true,
	sysmessage = true,
}
-- savedSets[panelId] = {
--		name = label,
--		slots[equipSlot] = {
--			icon = icon,
--			[dyeIndex(1..3)] = dyeColor,
--		}
--	}
KDSM.SetList = {}
-- KDSM.SetList = savedSets
KDSM.GlobalTable = {}
--[[	GlobalTable[<character>] = {
	--		classId = classId,
	--		savedSets = savedSets,
	--	}
]]

KDSM.settings = KDSM.defaults
KDSM.langString = nil
--KDSM.myCharacterName = nil
KDSM.positionning = false
KDSM.activate = false
KDSM.selectedPanel = nil
KDSM.sliderOffset = 1
KDSM.totalPanel = 0
KDSM.activeChar = nil
KDSM.selectedChar = nil
KDSM.characterList = {}

local MAX_PANEL = 5 --max panel printed slider

local TEXTURE_DYESLOT = "/esoui/art/dye/dye_amorslot.dds"
local TEXTURE_DYESLOTEMPTY = "/esoui/art/dye/dye_amorslot_empty.dds"
local TEXTURE_SAVEICON = "/esoui/art/dye/dyes_toolicon_sample_up.dds"
local TEXTURE_LOADICON = "/esoui/art/dye/dyes_toolicon_fill_up.dds"
local TEXTURE_ERASEICON = "/esoui/art/dye/dyes_toolicon_erase_up.dds"
local TEXTURE_SLIDER = "/esoui/art/miscellaneous/scrollbox_elevator.dds"
local TEXTURE_CLASS = {
	[0] = "/esoui/art/miscellaneous/help_icon.dds",
	[1] = "/esoui/art/contacts/social_classicon_dragonknight.dds",
	[2] = "/esoui/art/contacts/social_classicon_sorcerer.dds",
	[3] = "/esoui/art/contacts/social_classicon_nightblade.dds",
	[6] = "/esoui/art/contacts/social_classicon_templar.dds",
}

local COLOR_KHRILLSELECT = "FF6A00" -- orange ^^
local COLOR_NOCOLOR = "FFFFFF" --transparent
local COLOR_DISABLED = "303030" --"A0A0A0" -- gray
local COLOR_TEXT = "FFFFFF00" --"FFFACD" --white
local COLOR_ICON = COLOR_NOCOLOR --"C5C29E" --sand


-- // **********
-- //  Utility
-- // **********
local function HexToRGBA( hex )
	if string.len(hex) == 6 then hex = hex.."FF" end
    local rhex, ghex, bhex, ahex = string.sub(hex, 1, 2), string.sub(hex, 3, 4), string.sub(hex, 5, 6), string.sub(hex, 7, 8)
    return tonumber(rhex, 16)/255, tonumber(ghex, 16)/255, tonumber(bhex, 16)/255
end
local function RGBAToHex( r, g, b, a )
	if a == nil then a = 1 end
	r = r <= 1 and r >= 0 and r or 0
	g = g <= 1 and g >= 0 and g or 0
	b = b <= 1 and b >= 0 and b or 0
	return string.upper(string.format("%02x%02x%02x%02x", r * 255, g * 255, b * 255, a * 255))
end
local function isControlColorEgalTo(control, hexColor)
	return string.sub(RGBAToHex(control:GetColor()), 1, 6) == string.sub(hexColor, 1, 6)
end
local function TableCount(src)
	local count = 0
	if type(src) == 'table' then
		for k,v in pairs(src) do
			count = count +1
		end
	end
	return count
end
local function TableGetMaxKey(src)
	local max = nil
	if type(src) == 'table' then
		for k,v in pairs(src) do
			if (max == nil or k > max) then max = k end
		end
	end
	if max == nil then max = 0 end
	return max
end

local function addButton(parent, name, callbackFunction, text, font, tooltipText, tooltipAlign, textureNormal, textureMouseOver, textureClicked, color, width, height, left, top, alignValue, alignControl, alignControlValue, hideButton)
	--Add a button to an existing parent control (original code by Votan)
--	d("addButton "..name..","..tostring(hideButton))
	--Abort needed?
	if  (parent == nil or name == nil or callbackFunction == nil
		or width <= 0 or height <= 0 )
		and (textureNormal == nil or text == nil) then
			return nil
	end
	local button
    --Does the button already exist?
    button = WINDOW_MANAGER:GetControlByName(name, "")
    if button == nil then
        --Button does not exist yet and it should be hidden? Abort here!
        if hideButton == true then return nil end
        --Create the button control at the parent
        button = WINDOW_MANAGER:CreateControl(name, parent, CT_BUTTON)
    end
    --Button was created?
    if button ~= nil then
        -- -- Button should be hidden?
        -- if hideButton == false then
			local highlightColor = nil
			local isColorInitiated = false
			local defaultColor = color or COLOR_ICON
			button.color = defaultColor
            --Set the button's size
            button:SetDimensions(width, height)
            --Align the button
            if alignControl == nil then
                alignControl = parent
            end
            --SetAnchor(point, relativeTo, relativePoint, offsetX, offsetY)
			if alignValue == nil then alignValue = TOPLEFT end
			if alignControlValue == nil then alignControlValue = TOPLEFT end
			button:ClearAnchors()
            button:SetAnchor(alignValue, alignControl, alignControlValue, left, top)
            --Texture or text?
            if (text ~= nil) then
                --Text
				button.type = "Label"
				highlightColor = COLOR_KHRILLSELECT
				local label
                 --Check if label exists
                label = WINDOW_MANAGER:GetControlByName(name .. "Label", "")
                if label == nil then
                    --Create the label for the button to hold the text
                    label = WINDOW_MANAGER:CreateControl(name .. "Label", button, CT_LABEL)
                end
				label:SetAnchorFill()
				label:SetVerticalAlignment(TEXT_ALIGN_CENTER)
				label:SetHorizontalAlignment(TEXT_ALIGN_CENTER)
                --Set the label's font
                if font == nil then
                    label:SetFont("ZoFontGameSmall")
                else
                    label:SetFont(font)
                end
                --Set the button's text
                label:SetText(text)
				--Set default color
				label.color = defaultColor
				label:SetColor(HexToRGBA(defaultColor))
				label:SetHidden(false)
            else
                --Texture
				button.type = "Texture"
                local texture
                 --Check if texture exists
                texture = WINDOW_MANAGER:GetControlByName(name .. "Texture", "")
                if texture == nil then
                    --Create the texture for the button to hold the image
                    texture = WINDOW_MANAGER:CreateControl(name .. "Texture", button, CT_TEXTURE)
                end
                texture:SetAnchorFill()
                --Set the texture for normale state now
                texture:SetTexture(textureNormal)
                --Do we have seperate textures for the button states?
				if textureMouseOver == nil and textureClicked == nil then
					highlightColor = COLOR_KHRILLSELECT
					isColorInitiated = (isControlColorEgalTo(texture, highlightColor))
				end
				texture.color = defaultColor
				texture:SetColor(HexToRGBA(defaultColor))
                button.upTexture      = textureNormal
                button.downTexture    = textureMouseOver or textureNormal
                button.clickedTexture = textureClicked or textureNormal
            end
			button.highlightColor = highlightColor
			button.isColorInitiated = isColorInitiated
            if tooltipAlign == nil then tooltipAlign = TOP end
            --Set a tooltip?
            if tooltipText ~= nil then
                if button:GetHandler("OnMouseEnter") == nil then button:SetHandler("OnMouseEnter", function(self)
                    if self.downTexture then self:GetChild(1):SetTexture(self.downTexture) end
					if self.highlightColor ~= nil and not self.isColorInitiated then self:GetChild(1):SetColor(HexToRGBA(self.highlightColor)) end
                    ZO_Tooltips_ShowTextTooltip(self, tooltipAlign, tooltipText)
					end)
				end
                if button:GetHandler("OnMouseExit") == nil then button:SetHandler("OnMouseExit", function(self)
                    if self.upTexture then self:GetChild(1):SetTexture(self.upTexture) end
					if self.highlightColor ~= nil and not self.isColorInitiated then self:GetChild(1):SetColor(HexToRGBA(self.color)) end
                    ZO_Tooltips_HideTextTooltip()
					end)
				end
            else
                if button:GetHandler("OnMouseEnter") == nil then button:SetHandler("OnMouseEnter", function(self)
                    if self.downTexture then self:GetChild(1):SetTexture(self.downTexture) end
 					if self.highlightColor ~= nil and not self.isColorInitiated then self:GetChild(1):SetColor(HexToRGBA(self.highlightColor)) end
					end)
				end
                if button:GetHandler("OnMouseExit") == nil then button:SetHandler("OnMouseExit", function(self)
                    if self.upTexture then self:GetChild(1):SetTexture(self.upTexture) end
 					if self.highlightColor ~= nil and not self.isColorInitiated then self:GetChild(1):SetColor(HexToRGBA(self.color)) end
					end)
				end
            end
            --Set the callback function of the button
            if button:GetHandler("OnClicked") == nil then button:SetHandler("OnClicked", function(butn)
				-- if butn.highlightColor ~= nil and not butn.isColorInitiated then
					-- butn:GetChild(1):SetColor(HexToRGBA(butn.color)) 
					-- butn.isColorInitiated = not(butn.isColorInitiated)
				-- end
                callbackFunction()
				end)
			end
			if button:GetHandler("OnMouseDown") == nil then button:SetHandler("OnMouseDown", function(butn, ctrl, alt, shift, command)
				if butn.clickedTexture then butn:GetChild(1):SetTexture(butn.clickedTexture) end
				end)
			end
			--Show the button and make it react on mouse input
			button:SetHidden(hideButton) --false)
			button:SetMouseEnabled(not hideButton) --true)
			--Return the button control
			return button
		-- else
			-- --Hide the button and make it not reacting on mouse input
			-- button:SetHidden(true)
			-- button:SetMouseEnabled(false)
		-- end
	else
		return nil
	end
end
local function addEditbox(parent, name, callbackFunction, text)
	--build an editbox control (with label and edit zone)
	--Abort?
	if (parent == nil or name == nil) then
		return nil
	end

	local control
    --Does the control already exist?
    control = WINDOW_MANAGER:GetControlByName(name, "")
	if control == nil then
		control = WINDOW_MANAGER:CreateControl(name, parent, CT_CONTROL)
		control:SetMouseEnabled(true)
		control:SetResizeToFitDescendents(true)
		control:SetAnchor(TOPLEFT,parent,TOPLEFT,0,0)

		control.label = WINDOW_MANAGER:CreateControl(name.."Label", control, CT_LABEL)
		local label = control.label
		label:SetAnchor(TOPLEFT,control,TOPLEFT,0,2)
		label:SetFont("ZoFontWinT2")
		label:SetWrapMode(TEXT_WRAP_MODE_ELLIPSIS)

		control.bg = WINDOW_MANAGER:CreateControlFromVirtual(name.."BG", control, "ZO_EditBackdrop")
		local bg = control.bg

		control.editbox = WINDOW_MANAGER:CreateControlFromVirtual(name.."Editbox", bg, "ZO_DefaultEditForBackdrop")
		local editbox = control.editbox
		editbox:SetColor(HexToRGBA(COLOR_KHRILLSELECT))
		editbox:SetText("")
		editbox:SetMaxInputChars(100)
		if callbackFunction ~= nil then
			if editbox:GetHandler("OnFocusLost") == nil then editbox:SetHandler("OnFocusLost", function(self) callbackFunction() end) end
			if editbox:GetHandler("OnEscape") == nil then editbox:SetHandler("OnEscape", function(self) self:LoseFocus() callbackFunction() end) end
		end

		control:SetDimensions(280, 30)
		bg:SetDimensions(180, 24)
		bg:SetAnchor(TOPRIGHT, control, TOPRIGHT,0,0)
	end
	if text ~= nil then control.label:SetText(text) else control:SetDimensions(180, 30) end
	control:SetHidden(false)
	
	return control
end


-- // **********
-- //  Events
-- // **********
function KDSM:OnStationInteract(eventCode)
	-- // active station
--d("--OnStation")
	if KDSM.settings.enable then
		-- ESOUI in back layer (avoid interaction with buttons)
		DYEING.control:SetDrawLayer(DL_BACKGROUND)
		KDSM:OpenUI()
	end
end
function KDSM:OnEndStation(eventCode)
--	d("--OnEndStation")
	KDSM:CloseUI()
end

function KDSM:OnSliderMove(value)
--d("--OnSliderMove:"..value)
	KDSM.sliderOffset = value
	KDSM:updatePanels()
end
function KDSM:OnMouseWheel(delta)
--d("--OnMouseWheel:"..delta..","..KDSM.sliderOffset)
	local offset = KDSM.sliderOffset
	offset = offset - delta
	if (offset > KDSM.totalPanel-MAX_PANEL) then offset = KDSM.totalPanel-MAX_PANEL+1 end
	if (offset < 1) then offset = 1 end
	
	KDSM.sliderOffset = offset
	KDSMUISlider:SetValue(offset)
	KDSM:updatePanels()
end

function KDSM_ToggleChar(name)
	-- button for change selectedChar
--d("--ToggleChar: "..name)
	KDSM.selectedChar = name
	KDSM.SetList = {}
	KDSM.SetList = KDSM.GlobalTable[KDSM.selectedChar].savedSets
	KDSM:CleanUI()
	KDSM:OpenUI()
	KDSM:updatePanels()
end


-- // **********
-- //  DYE SETS
-- // **********
local function saveDataInVars()
	-- save in savedVar & in GlobalTable
	-- (can be called from save, erase and rename label actions)
	KDSM.settings.savedSets = KDSM.SetList
	if KDSM.GlobalTable[KDSM.activeChar] == nil then
		KDSM.GlobalTable[KDSM.activeChar] = {}
		KDSM.GlobalTable[KDSM.activeChar].classId = GetUnitClassId("player")
		table.insert(KDSM.characterList, KDSM.activeChar)
	end
	KDSM.GlobalTable[KDSM.activeChar].savedSets = KDSM.SetList
end

function KDSM_OnSave(panelId)
--d("--OnSave:"..tostring(panelId))
	-- save dying set to settings var
	local slots = {}
    for i, equipSlot in ipairs(ZO_DYEABLE_EQUIP_SLOTS) do
--	d(i..": equipSlot="..equipSlot)
		local icon, slotHasItem, _, _, _, _ = GetEquippedItemInfo(equipSlot)
		if slotHasItem then
			slots[equipSlot] = {}
			slots[equipSlot].icon = icon
			for dyeIndex=1,3 do
				local dyeColor = select(dyeIndex, GetPendingEquippedItemDye(equipSlot))
--	d(dyeIndex.."->"..tostring(dyeColor))
				slots[equipSlot][dyeIndex] = dyeColor
			end
		end
	end
	KDSM.SetList[panelId] = {name = KDSM.langString.MESSAGE_Save.." "..panelId, slots = slots}
	saveDataInVars()

	local panelControl = KDSM:addPanel(panelId)
	PlaySound(SOUNDS.DYEING_APPLY_CHANGES)
	-- if last slot, then add a new one
	if panelId == KDSM.totalPanel then
		KDSM:addPanel(panelId+1)
		KDSM.totalPanel = KDSM.totalPanel +1 --	= TableGetMaxKey(KDSM.SetList) +1
	end
	KDSM:refreshSlider()
	panelControl.load:SetHidden(false)
	panelControl.erase:SetHidden(false)
	if KDSM.settings.sysmessage then
		CHAT_SYSTEM:AddMessage("|c"..COLOR_KHRILLSELECT.."["..KDSM.name.."]|r : "..KDSM.langString.MESSAGE_Save.." Set "..panelId.." OK")
	end
end
function KDSM_OnLoad(panelId)
--d("--OnLoad:"..tostring(panelId))
	-- change dyeing in ESO UI
	for i, equipSlot in ipairs(ZO_DYEABLE_EQUIP_SLOTS) do
		local _, slotHasItem, _, _, _, _ = GetEquippedItemInfo(equipSlot)
		if slotHasItem and KDSM.SetList[panelId].slots[equipSlot] then SetPendingEquippedItemDye(equipSlot, KDSM.SetList[panelId].slots[equipSlot][1],KDSM.SetList[panelId].slots[equipSlot][2],KDSM.SetList[panelId].slots[equipSlot][3]) end
--		if slotHasItem and KDSM.settings.savedSets[panelId].slots[equipSlot] then SetPendingEquippedItemDye(equipSlot, KDSM.settings.savedSets[panelId].slots[equipSlot][1],KDSM.settings.savedSets[panelId].slots[equipSlot][2],KDSM.settings.savedSets[panelId].slots[equipSlot][3]) end
	end
	PlaySound(SOUNDS.DYEING_TOOL_FILL_USED)
	_G["DYEING"]:OnPendingDyesChanged()
	if KDSM.settings.sysmessage then
		CHAT_SYSTEM:AddMessage("|c"..COLOR_KHRILLSELECT.."["..KDSM.name.."]|r : "..KDSM.langString.MESSAGE_Load.." Set "..panelId.." OK")
	end
end
function KDSM_OnErase(panelId)
--d("--OnErase:"..tostring(panelId))
	KDSM.SetList[panelId] = nil
	local panelControl = KDSM:addPanel(panelId)
	saveDataInVars()
	PlaySound(SOUNDS.DYEING_TOOL_ERASE_USED)
	-- check panel to del last panels if needed
	local newTotal = TableGetMaxKey(KDSM.SetList) +1
	if newTotal < KDSM.totalPanel then
		-- hide extra slots
		for i=newTotal+1, KDSM.totalPanel do
			GetControl("KDSM_Panel_"..tostring(i)):SetHidden(true)
		end
		KDSM.totalPanel = newTotal
	end
	KDSM:refreshSlider()
	panelControl.label:SetColor(HexToRGBA(COLOR_KHRILLSELECT))
	panelControl.label:SetMouseEnabled(false)
	panelControl.load:SetHidden(true)
	panelControl.erase:SetHidden(true)
	if KDSM.settings.sysmessage then
		CHAT_SYSTEM:AddMessage("|c"..COLOR_KHRILLSELECT.."["..KDSM.name.."]|r : "..KDSM.langString.MESSAGE_Erase.." Set "..panelId.." OK")
	end
end
function KDSM_OnNameChanged(panelId)
--d("OnNameChanged: "..panelId)
	local panelControl = GetControl("KDSM_Panel_"..tostring(panelId))
	local entry = panelControl:GetNamedChild("Edit").editbox:GetText()
	if entry ~= nil and entry ~= "" then
		panelControl.label:SetText(entry)
		KDSM.SetList[panelId].name = entry
		saveDataInVars()
	end
	panelControl.label:SetHidden(false)
	panelControl:GetNamedChild("Edit"):SetHidden(true)
end


-- // **********
-- //  UI PANEL
-- // **********
function KDSM:addPanel(panelId)
	-- add a saved set
--d("--addPanel:"..panelId)
	local panelControl = GetControl("KDSM_Panel_"..tostring(panelId))
	if panelControl == nil then
		panelControl = CreateControlFromVirtual("KDSM_Panel_", KDSMUI, "KDSM_Panel", tostring(panelId))
		panelControl:SetAnchor(TOPLEFT, KDSMUI, TOPLEFT, 10, 10+(panelId-1)*(panelControl:GetHeight()+15))
		panelControl:SetHandler("OnMouseDown", function(butn, ctrl, alt, shift, command) KDSM_OnPanelSelect(panelId) end)
		panelControl:SetHandler("OnMouseWheel", function(self, delta) KDSM:OnMouseWheel(delta) end)
		-- buttons
		panelControl.save = addButton(panelControl, panelControl:GetName().."SaveButton", function(...) KDSM_OnSave(panelId) end, nil, nil, KDSM.langString.MESSAGE_Save, BOTTOM, TEXTURE_SAVEICON, nil, nil, nil, 32, 32, -10, 0, RIGHT, panelControl, LEFT, false)
		panelControl.load = addButton(panelControl, panelControl:GetName().."LoadButton", function(...) KDSM_OnLoad(panelId) end, nil, nil, KDSM.langString.MESSAGE_Load, BOTTOM, TEXTURE_LOADICON, nil, nil, nil, 32, 32, 5, 0, RIGHT, panelControl.save, LEFT, false)
		panelControl.erase = addButton(panelControl, panelControl:GetName().."EraseButton", function(...) KDSM_OnErase(panelId) end, nil, nil, KDSM.langString.MESSAGE_Erase, BOTTOM, TEXTURE_ERASEICON, nil, nil, nil, 32, 32, 5, 0, RIGHT, panelControl.load, LEFT, false)
		panelControl.save:SetDrawLayer(DL_OVERLAY)
		panelControl.load:SetDrawLayer(DL_OVERLAY)
		panelControl.erase:SetDrawLayer(DL_OVERLAY)
		panelControl.save:SetDrawTier(DT_HIGH)
		panelControl.load:SetDrawTier(DT_HIGH)
		panelControl.erase:SetDrawTier(DT_HIGH)
		panelControl.save:SetHidden(true)
		panelControl.load:SetHidden(true)
		panelControl.erase:SetHidden(true)
		panelControl:GetNamedChild("BG"):SetEdgeColor(HexToRGBA(COLOR_DISABLED))
		-- place text
		local labelControl = panelControl:GetNamedChild("Label")
		labelControl:SetMouseEnabled(false)
		labelControl:SetHandler("OnMouseDown", function(...) KDSM_EditLabel(panelId) end)
		panelControl.label = labelControl
	end
	
	if KDSM.SetList[panelId] == nil then
		-- no record (empty)
		KDSM:reinitPanel(panelControl)
		if (panelId+KDSM.sliderOffset-1) == 3 then KDSM:showTitle(false) end
		return panelControl
	end
	panelControl.label:SetText(KDSM.SetList[panelId].name)
	panelControl.label:SetColor(HexToRGBA(COLOR_TEXT))
	panelControl.empty = false
	if (panelId+KDSM.sliderOffset-1) == 3 then KDSM:showTitle(false) end

	-- Unit for each equipSlot
	local slots = KDSM.SetList[panelId].slots
	local i = 0
    for _, equipSlot in ipairs(ZO_DYEABLE_EQUIP_SLOTS) do
		local doIt = true
	    if equipSlot == EQUIP_SLOT_OFF_HAND or equipSlot == EQUIP_SLOT_BACKUP_OFF then
			doIt = (equipSlot == ZO_Dyeing_GetActiveOffhandEquipSlot()) --shield 1 instance
		end
		if doIt then
			i = i +1
--	d(i..": equipSlot="..equipSlot)
--	d(slots[equipSlot])
			if slots[equipSlot] == nil then
				local icon, slotHasItem, _, _, _, _ = GetEquippedItemInfo(equipSlot)
				if icon == nil or icon == "" then icon = ZO_Character_GetEmptyEquipSlotTexture(equipSlot) end
				slots[equipSlot] = {}
				slots[equipSlot].icon = icon
				for dyeIndex=1,3 do
					slots[equipSlot][dyeIndex] = nil
				end
			end
			local slotControl = GetControl("KDSM_Panel_"..tostring(panelId).."Slot"..tostring(i))
			if slotControl == nil then
				slotControl = CreateControlFromVirtual("KDSM_Panel_"..tostring(panelId), panelControl, "KDSM_Unit", "Slot"..tostring(i))
				slotControl:SetHandler("OnMouseWheel", function(self, delta) KDSM:OnMouseWheel(delta) end)
				slotControl:SetAnchor(RIGHT, panelControl, RIGHT, -(#ZO_DYEABLE_EQUIP_SLOTS-1-i)*55+10, 0)
			end
			slotControl:SetHidden(false)
				
			local iconControl = slotControl:GetNamedChild("Icon")
			iconControl:SetTexture(slots[equipSlot].icon)
			for dyeIndex=1,3 do
				local dyeControl = slotControl:GetNamedChild("Dye"..dyeIndex)
				local dyeColor = slots[equipSlot][dyeIndex]
	--	d(dyeIndex.."->"..tostring(dyeColor))
				if dyeColor ~= nil then
					dyeControl:SetTexture(TEXTURE_DYESLOT)
					local _, _, _, _, _, r, g, b, _ = GetDyeInfo(dyeColor)
					dyeControl:GetNamedChild("BG"):SetColor(r, g, b, 1)
				else
					dyeControl:SetTexture(TEXTURE_DYESLOTEMPTY)
					dyeControl:GetNamedChild("BG"):SetColor(0, 0, 0, 0)
				end
			end
		end
	end
	panelControl:SetHidden(false)

	return panelControl
end
function KDSM:updatePanels()
	-- update printed panels with scroll slider position
--	d("updatePanels: offset="..KDSM.sliderOffset)
	for panelId= 1, KDSM.totalPanel do
		local panelControl = GetControl("KDSM_Panel_"..tostring(panelId))
		if panelId >= KDSM.sliderOffset and panelId <= MAX_PANEL+KDSM.sliderOffset-1 then
			panelControl:ClearAnchors()
			panelControl:SetAnchor(TOPLEFT, KDSMUI, TOPLEFT, 10, 10+(panelId-KDSM.sliderOffset)*(panelControl:GetHeight()+15))
			panelControl:SetHidden(false)
		else
			panelControl:SetHidden(true)
		end
		if (panelId+KDSM.sliderOffset-1) == 3 then KDSM:showTitle(panelControl.empty) end
	end
end
function KDSM:refreshSlider()
	--scroll slider
	KDSMUISlider:SetMinMax(1,KDSM.totalPanel-MAX_PANEL+1)
	KDSMUISlider:SetValue(1)
	KDSMUISlider:SetHidden(KDSM.totalPanel == MAX_PANEL)
end
function KDSM:reinitPanel(panelControl)
--d("--removePanel:"..panelControl:GetName())
	if panelControl ~= nil then
		panelControl.empty = true
		panelControl:SetHidden(false)
		panelControl.label:SetColor(HexToRGBA(COLOR_DISABLED))
		panelControl.label:SetText("--"..KDSM.langString.MESSAGE_EMPTY.."--")
		panelControl.label:SetMouseEnabled(false)
	    for i, equipSlot in ipairs(ZO_DYEABLE_EQUIP_SLOTS) do
			if panelControl:GetNamedChild("Slot"..tostring(i)) then panelControl:GetNamedChild("Slot"..tostring(i)):SetHidden(true) end
		end
	end
end
function KDSM:CleanUI()
--d("--CleanUI")
	for panelId=1,KDSM.totalPanel do
		local panelControl = GetControl("KDSM_Panel_"..tostring(panelId))
		if panelControl ~= nil then
			panelControl:GetNamedChild("BG"):SetEdgeColor(HexToRGBA(COLOR_DISABLED))
			panelControl.label:SetMouseEnabled(false)
			panelControl.save:SetHidden(true)
			panelControl.load:SetHidden(true)
			panelControl.erase:SetHidden(true)
			panelControl:SetHidden(true)
		end
	end
	KDSM.sliderOffset = 1
	KDSMUISlider:SetValue(1)
	KDSM.selectedPanel = nil
end
function KDSM_EditLabel(panelId)
--d("--EditLabel:"..panelId)
	local panelControl = GetControl("KDSM_Panel_"..tostring(panelId))
	local control = addEditbox(panelControl, panelControl:GetName().."Edit", function() KDSM_OnNameChanged(panelId) end, nil)
	control.editbox:SetText(panelControl.label:GetText())
	panelControl.label:SetHidden(true)
	control:SetHidden(false)
	control.editbox:TakeFocus()
end

function KDSM_OnPanelSelect(panelId)
--d("--KDSM_OnPanelSelect: "..tostring(panelId)..","..tostring(KDSM.selectedPanel))
	local panelControl = GetControl("KDSM_Panel_"..tostring(panelId))
	if panelControl == nil then return end
	
	if KDSM.selectedPanel == panelId then --deselect
		panelControl:GetNamedChild("BG"):SetEdgeColor(HexToRGBA(COLOR_DISABLED))
		if panelControl.empty then
			panelControl.label:SetColor(HexToRGBA(COLOR_DISABLED))
		else
			panelControl.label:SetColor(HexToRGBA(COLOR_TEXT))
		end
		panelControl.label:SetMouseEnabled(false)
		KDSM.selectedPanel = nil
		panelControl.save:SetHidden(true)
		panelControl.load:SetHidden(true)
		panelControl.erase:SetHidden(true)
	else
		-- deselect old
		if KDSM.selectedPanel ~= nil then KDSM_OnPanelSelect(KDSM.selectedPanel) end
		-- select new
		panelControl:GetNamedChild("BG"):SetEdgeColor(HexToRGBA(COLOR_KHRILLSELECT))
		panelControl.label:SetColor(HexToRGBA(COLOR_KHRILLSELECT))
		panelControl.label:SetMouseEnabled(not panelControl.empty)
		KDSM.selectedPanel = panelId
		panelControl.save:SetHidden(KDSM.selectedChar~=KDSM.activeChar)
		if not panelControl.empty then
			panelControl.load:SetHidden(false)
			panelControl.erase:SetHidden(KDSM.selectedChar~=KDSM.activeChar)
		end
	end
end

function KDSM:OpenUI()
--d("--OpenUI")
	KDSM:registerEvents(true)

	KDSM.totalPanel = TableGetMaxKey(KDSM.SetList) +1

	if KDSM.totalPanel < MAX_PANEL then KDSM.totalPanel = MAX_PANEL end
	for i=1,KDSM.totalPanel do
		KDSM:addPanel(i)
	end
	KDSM:refreshSlider()
	KDSM:addCharButton()
	KDSMUI:SetHidden(false)
end
function KDSM:CloseUI()
--d("--CloseUI")
	KDSM:registerEvents(false)
	KDSMUI:SetHidden(true)
end
function KDSM:showTitle(state)
	KDSMUIIcon:SetHidden(not state)
	KDSMUILabel:SetHidden(not state)
end

function KDSM:addCharButton()
--d("--addCharButton: "..KDSM.selectedChar)
	-- add a button for each character who have crafting quests
	local cpt = 0
	local supportControl = GetControl("KDSMUICharPanel")
	supportControl:SetHidden(not KDSM.settings.charButton)
	local nameControl = GetControl("KDSMUICharName")
	local name, data
	for i=1, #KDSM.characterList do
		name = KDSM.characterList[i]
		data = KDSM.GlobalTable[name]
		if name == KDSM.selectedChar then
			nameControl:SetText(name)
			if name == KDSM.activeChar then --active character in orange
				nameControl:SetColor(HexToRGBA(COLOR_KHRILLSELECT))
				nameControl:SetStyleColor(HexToRGBA("000000FF"))
			else
				nameControl:SetColor(HexToRGBA(COLOR_TEXT))
				nameControl:SetStyleColor(HexToRGBA(COLOR_KHRILLSELECT))
			end
		end
		if data.savedSets ~= nil then --and name ~= KDSM.selectedChar then
			local button = addButton(supportControl, "KDSMUICharPanelButton"..name, function(...) KDSM_ToggleChar(KDSM.characterList[i]) end, nil, nil, "|c"..COLOR_KHRILLSELECT..name.."|r", BOTTOM, TEXTURE_CLASS[data.classId], nil, nil, nil, 24, 24, 25*cpt, 0, LEFT, supportControl, LEFT, false)
			if name == KDSM.selectedChar then --highlight orange
				button:GetChild(1):SetColor(HexToRGBA(COLOR_KHRILLSELECT))
				button.isColorInitiated = true
			else
				button:GetChild(1):SetColor(HexToRGBA(COLOR_TEXT))
			end
--			button:SetHidden(false)
			cpt = cpt +1
		end
	end
end


-- // **********
-- //  Init
-- // **********
function KDSM_SaveAnchor()
	-- Save the new position of windows
--d("--SaveAnchor")
	-- Alarm window
	local isValidAnchor, point, relativeTo, relativePoint, offsetX, offsetY = KDSMUI:GetAnchor()
	if isValidAnchor then
		KDSM.settings.anchor = { point, relativePoint, offsetX, offsetY }
	end
end
function KDSM:GetLanguage()
	local lang = GetCVar("language.2")

	--supported languages
	if(lang == "fr") then return lang end
	if(lang == "de") then return lang end
	if(lang == "es") then return lang end

	--return english if not supported
	return "en"
end

function KDSM:OnInit(eventCode, addOnName)
    if ( addOnName ~= KDSM.name) then return end
	
	KDSM.langString = KDSM_Lang[KDSM:GetLanguage()]
	--settings
	KDSM.settings = ZO_SavedVars:New(KDSM.name .. "_settings", 1, nil, KDSM.defaults)
--	KDSM.settings = KDSM.defaults --reinit for test
	KDSM:CommandOptionPanel()

	-- position
	KDSMUI:ClearAnchors()
	KDSMUI:SetAnchor(KDSM.settings.anchor[1], KDSMUI:GetParent(), KDSM.settings.anchor[2], KDSM.settings.anchor[3], KDSM.settings.anchor[4])

	-- scroll slider
	local slider = CreateControl("KDSMUISlider", KDSMUI, CT_SLIDER)
	slider:SetDrawLayer(DL_CONTROLS)
	slider:SetDimensions(25,KDSMUI:GetHeight())
	slider:SetMouseEnabled(true)
	slider:SetThumbTexture(TEXTURE_SLIDER,TEXTURE_SLIDER,TEXTURE_SLIDER,20,tonumber(KDSMUI:GetHeight()/2),0,0,1,1)
	slider:SetValueStep(1)
	slider:SetAnchor(TOPRIGHT,KDSMUI,TOPRIGHT,5,0)
	slider:SetHandler("OnValueChanged",function(self,value,eventReason) KDSM:OnSliderMove(value) end)

	--init var
	KDSM.activeChar = zo_strformat(SI_UNIT_NAME, GetRawUnitName("player"))
	KDSM.settings.classId = GetUnitClassId("player")
	KDSM.selectedChar = KDSM.activeChar
	KDSM.SetList = KDSM.settings.savedSets
	-- build characters list & global saved sets
	local characterList = {}
	for account, accountData in pairs(KhrillDyeingSetMatch_settings.Default) do
		if account == ZO_DisplayNameDisplayName:GetText() then
			for player, data in pairs (accountData) do
				if data.savedSets ~= nil then table.insert(characterList, player) end
			end
			table.sort(characterList)
			KDSM.characterList = characterList
			
			for i=1, #characterList do
				player = characterList[i]
				if accountData[player] then
					data = accountData[player]
					KDSM.GlobalTable[player] = {}
					if data.classId ~= nil then KDSM.GlobalTable[player].classId = data.classId end
					if data.savedSets ~= nil then KDSM.GlobalTable[player].savedSets = data.savedSets end
				end
			end
		end
	end

	EVENT_MANAGER:RegisterForEvent(KDSM.name, EVENT_DYEING_STATION_INTERACT_START, function(...) KDSM:OnStationInteract(...) end)

	EVENT_MANAGER:UnregisterForEvent(KDSM.name, EVENT_ADD_ON_LOADED)
end
function KDSM:registerEvents(state)
	if state then
		EVENT_MANAGER:RegisterForEvent(KDSM.name, EVENT_DYEING_STATION_INTERACT_END, function(...) KDSM:OnEndStation(...) end)
	else
		EVENT_MANAGER:UnregisterForEvent(KDSM.name, EVENT_DYEING_STATION_INTERACT_END)
	end
end

EVENT_MANAGER:RegisterForEvent(KDSM.name, EVENT_ADD_ON_LOADED , function(_event, _name) KDSM:OnInit(_event, _name) end)


-- // **********
-- //  Settings
-- // **********
function KDSM:ToggleEnable(value)
	KDSM.settings.enable = value
	KDSM:registerEvents(KDSM.settings.enable)	
end
function KDSM:TogglePositionning(value)
	KDSM.positionning = value
	-- enable/disabled movable frame and BG
	KDSM:CleanUI()
	KDSM:showTitle(true)
	KDSMUI:SetHidden(not KDSM.positionning)
end


function KDSM:CommandOptionPanel()
	--// Settings panel LAM2
	local LAM2 = LibStub("LibAddonMenu-2.0")
	if ( not LAM2 ) then return end
	
	local ADDON_NAME="Dyeing Set & Match"
	local ADDON_VERSION="v"..KDSM.version
	local panelData = {
			type = "panel",
			name = ADDON_NAME,
			displayName = "|c"..COLOR_KHRILLSELECT.. ADDON_NAME .."|r (" .. KDSM.langString.LOCALE .. ")",
			author = "|c"..COLOR_KHRILLSELECT.."Khrill|r",
			version = ADDON_VERSION,
			slashCommand = "/kda",
			registerForRefresh = true,
			registerForDefaults = true,
	}
	local settingsPanel = LAM2:RegisterAddonPanel(ADDON_NAME, panelData)

	local optionsTable = {
		------------SETTINGS--------------
		{	-- enable
			type = "checkbox",
			name = KDSM.langString.Settings_enable,
--			tooltip = KDSM.langString.Settings_enable,
			getFunc = function() return KDSM.settings.enable end,
			setFunc = function(value) KDSM:ToggleEnable(value) end,
			width = "full",
			default = KDSM.defaults.enable,
		},
		{
			type = "header",
			name = "|c"..COLOR_KHRILLSELECT..KDSM.langString.Settings_control.."|r",
			width = "full",
		},
		{	-- characters buttons
			type = "checkbox",
			name = KDSM.langString.Settings_charBtn,
			tooltip = KDSM.langString.Settings_charBtn,
			getFunc = function() return KDSM.settings.charButton end,
			setFunc = function(value)
				KDSM.settings.charButton = value
				KCPUICharPanel:SetHidden(not KDSM.settings.charButton)
			end,
			width = "full",
			default = KDSM.defaults.charButton,
		},
		{	-- sysmessage
			type = "checkbox",
			name = KDSM.langString.Settings_sysmessage,
--			tooltip = KDSM.langString.Settings_enable,
			getFunc = function() return KDSM.settings.sysmessage end,
			setFunc = function(value) KDSM.settings.sysmessage = value end,
			width = "full",
			default = KDSM.defaults.sysmessage,
		},
		
		------------positionning--------------
		{
			type = "header",
			name = "|c"..COLOR_KHRILLSELECT..KDSM.langString.Settings_positionning.."|r",
			width = "full",
		},
		{
			type = "description",
			text = KDSM.langString.Settings_positionningText,
			width = "full",
		},
		{
			type = "checkbox",
			name = KDSM.langString.Settings_enable,
--			tooltip = KDSM.langString.Settings_enable,
			getFunc = function() return KDSM.positionning end,
			setFunc = function(value) KDSM:TogglePositionning(value) end,
			width = "full",
			default = false,
		},
	}

	LAM2:RegisterOptionControls(ADDON_NAME, optionsTable)
end

SLASH_COMMANDS["/KDSMdebug"] = function()

 end
